/**
*	ut.c
*	Tu[`W
*	Copyright (c)Junnichi Tomaru
*/
#include	<avr/pgmspace.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"ut.h"

const char	hexnum[] = "0123456789ABCDEF";


/**
*	lPUi(unsigned char)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoahz( byte num, char *buf )
{
	union{
		byte	data;
		struct{
			byte	lo : 4;	/* ʂSrbg */
			byte	hi : 4;	/* ʂSrbg */
		} nbl;
	} uni;

	uni.data = num;
	*( buf + 0 ) = hexnum[uni.nbl.hi];
	*( buf + 1 ) = hexnum[uni.nbl.lo];
	*( buf + 2 ) = '\0';

	return	buf;
}


/**
*	lPOi(unsigned char,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoaz( byte num, char *buf )
{
	byte	n;
	char	i, *p;

	p = buf;
	for( n = 100; n > 1; n /= 10, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + '0' );
	}
	*p = num + '0';
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned short,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*utoaz( word num, char *buf )
{
	word	n;
	int	i;
	char	*p;

	p = buf;
	for( n = 10000U; n > 1; n /= 10, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + 0x30 );
	}
	*p = num + 0x30;
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	zXglbg[ÑoCgI[_ϊ(16bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
word	htons( word data )
{
#if defined( LITTLE_ENDIAN )
	ui_t	ret, tmp;

	tmp.data = data;
	ret.bytes.lo = tmp.bytes.hi;
	ret.bytes.hi = tmp.bytes.lo;
	return	ret.data;
#else
	return	data;
#endif
}


/**
*	lbg[NzXg̃oCgI[_ϊ(16bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
word	ntohs( word data )
{
	return	htons( data );
}


/**
*	zXglbg[ÑoCgI[_ϊ(32bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
dword	htonl( dword data )
{
#if defined( LITTLE_ENDIAN )
	ul_t	ret, w;

	w.data = data;
	ret.bytes.ll = w.bytes.hh;
	ret.bytes.lh = w.bytes.hl;
	ret.bytes.hl = w.bytes.lh;
	ret.bytes.hh = w.bytes.ll;
	return	ret.data;
#else
	return	data;
#endif
}


/**
*	lbg[NzXg̃oCgI[_ϊ(32bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
dword	ntohl( dword data )
{
#if defined( LITTLE_ENDIAN )
	ul_t	ret, w;

	w.data = data;
	ret.bytes.ll = w.bytes.hh;
	ret.bytes.lh = w.bytes.hl;
	ret.bytes.hl = w.bytes.lh;
	ret.bytes.hh = w.bytes.ll;
	return	ret.data;
#else
	return	data;
#endif
}


/**
*	hoAhX𕶎ɂ
*	 in	ipadr:hoAhX
*		  buf:i[敶
*	out	obt@|C^
*/
char	*inet_ntoa( dword ipadr, char *buf )
{
	ul_t	tmp;
	char	*p;

	tmp.data = ipadr;
	uctoaz( tmp.bytes.hh, buf );
	strcat_P( buf, PSTR( "." ));
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.hl, p + 1 );
	strcat_P( buf, PSTR( "." ));
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.lh, p + 1 );
	strcat_P( buf, PSTR( "." ));
	p = strrchr( buf, '.' );
	uctoaz( tmp.bytes.ll, p + 1 );

	return	buf;
}


/* end of ut.c */
