/**
*	w5100.c
*	W5100hCo  ver.0.1.1
*	Copyright (c)Junnichi Tomaru
*/
#include	<avr/io.h>
#include	"userdef.h"
#include	"w5100.h"

#define	CS_ASSERT()	asm("cbi 0x05, 2"::)
#define	CS_NEGATE()	asm("sbi 0x05, 2"::)

/* ---------- \Pbg̃WX^z ---------- */
const word	sn_mr[] = { S0_MR, S1_MR, S2_MR, S3_MR };
const word	sn_cr[] = { S0_CR, S1_CR, S2_CR, S3_CR };
const word	sn_ir[] = { S0_IR, S1_IR, S2_IR, S3_IR };
const word	sn_sr[] = { S0_SR, S1_SR, S2_SR, S3_SR };
const word	sn_port0[] = { S0_PORT0, S1_PORT0, S2_PORT0, S3_PORT0 };
const word	sn_port1[] = { S0_PORT1, S1_PORT1, S2_PORT1, S3_PORT1 };
const word	sn_dhar0[] = { S0_DHAR0, S1_DHAR0, S2_DHAR0, S3_DHAR0 };
const word	sn_dhar1[] = { S0_DHAR1, S1_DHAR1, S2_DHAR1, S3_DHAR1 };
const word	sn_dhar2[] = { S0_DHAR2, S1_DHAR2, S2_DHAR2, S3_DHAR2 };
const word	sn_dhar3[] = { S0_DHAR3, S1_DHAR3, S2_DHAR3, S3_DHAR3 };
const word	sn_dhar4[] = { S0_DHAR4, S1_DHAR4, S2_DHAR4, S3_DHAR4 };
const word	sn_dhar5[] = { S0_DHAR5, S1_DHAR5, S2_DHAR5, S3_DHAR5 };
const word	sn_dipr0[] = { S0_DIPR0, S1_DIPR0, S2_DIPR0, S3_DIPR0 };
const word	sn_dipr1[] = { S0_DIPR1, S1_DIPR1, S2_DIPR1, S3_DIPR1 };
const word	sn_dipr2[] = { S0_DIPR2, S1_DIPR2, S2_DIPR2, S3_DIPR2 };
const word	sn_dipr3[] = { S0_DIPR3, S1_DIPR3, S2_DIPR3, S3_DIPR3 };
const word	sn_dport0[] = { S0_DPORT0, S1_DPORT0, S2_DPORT0, S3_DPORT0 };
const word	sn_dport1[] = { S0_DPORT1, S1_DPORT1, S2_DPORT1, S3_DPORT1 };
const word	sn_mssr0[] = { S0_MSSR0, S1_MSSR0, S2_MSSR0, S3_MSSR0 };
const word	sn_mssr1[] = { S0_MSSR0, S1_MSSR1, S2_MSSR1, S3_MSSR1 };
const word	sn_proto[] = { S0_PROTO, S1_PROTO, S2_PROTO, S3_PROTO };
const word	sn_tos[] = { S0_TOS, S1_TOS, S2_TOS, S3_TOS };
const word	sn_ttl[] = { S0_TTL, S1_TTL, S2_TTL, S3_TTL };
const word	sn_tx_fsr0[] = { S0_TX_FSR0, S1_TX_FSR0, S2_TX_FSR0, S3_TX_FSR0 };
const word	sn_tx_fsr1[] = { S0_TX_FSR1, S1_TX_FSR1, S2_TX_FSR1, S3_TX_FSR1 };
const word	sn_tx_rd0[] = { S0_TX_RD0, S1_TX_RD0, S2_TX_RD0, S3_TX_RD0 };
const word	sn_tx_rd1[] = { S0_TX_RD1, S1_TX_RD1, S2_TX_RD1, S3_TX_RD1 };
const word	sn_tx_wr0[] = { S0_TX_WR0, S1_TX_WR0, S2_TX_WR0, S3_TX_WR0 };
const word	sn_tx_wr1[] = { S0_TX_WR1, S1_TX_WR1, S2_TX_WR1, S3_TX_WR1 };
const word	sn_rx_rsr0[] = { S0_RX_RSR0, S1_RX_RSR0, S2_RX_RSR0, S3_RX_RSR0 };
const word	sn_rx_rsr1[] = { S0_RX_RSR1, S1_RX_RSR1, S2_RX_RSR1, S3_RX_RSR1 };
const word	sn_rx_rd0[] = { S0_RX_RD0, S1_RX_RD0, S2_RX_RD0, S3_RX_RD0 };
const word	sn_rx_rd1[] = { S0_RX_RD1, S1_RX_RD1, S2_RX_RD1, S3_RX_RD1 };
const word	sn_rx_wr0[] = { S0_RX_WR0, S1_RX_WR0, S2_RX_WR0, S3_RX_WR0 };
const word	sn_rx_wr1[] = { S0_RX_WR1, S1_RX_WR1, S2_RX_WR1, S3_RX_WR1 };


/* -------------------- SPI -------------------- */

/**
*	SPIʐM(8bit)
*	 in	Mf[^
*	out	Mf[^
*/
byte	spiseq( char data )
{
	SPDR = data;		 /* f[^M */
	loop_until_bit_is_set( SPSR, SPIF );	 /* ]܂őҋ@*/

	return	SPDR;		/* Mf[^ */
}


/* -------------------- {ǂݏ -------------------- */

/**
*	W5100WX^֏
*	 in	addr: AhX
*		data: f[^
*	out	Ȃ
*/
void	w5100_write( word addr, byte data )
{
	ui_t	t;

	t.data = addr;
#if defined( DIRECT_BUS )	/* _CNg[h */
	*((vbyte*)(addr)) = data;
#elif defined( INDIRECT_BUS )	/* C_CNg[h */
	IDM_AR0 = t.bytes.hi;
	IDM_AR1 = t.bytes.lo;
	IDM_DR = data;
#elif defined( SPI_BUS )	/* SPI[h */
	CS_ASSERT( );
	spiseq( SPI_WRITE );	/* ݃R}h */
	spiseq( t.bytes.hi );
	spiseq( t.bytes.lo );
	spiseq( data );
	CS_NEGATE( );
#endif
}


/**
*	W5100WX^ǂݍ
*	 in	AhX
*	out	f[^
*/
byte	w5100_read( word addr )
{
	ui_t	t;
	byte	data;

	t.data = addr;

#if defined( DIRECT_BUS )
	data = addr;
#elif defined( INDIRECT_BUS )
	IDM_AR0 = t.bytes.hi;
	IDM_AR1 = t.bytes.lo;
	data = IDM_DR;
#elif defined( SPI_BUS )
	CS_ASSERT( );
	spiseq( SPI_READ );	/* ǂݏoR}h */
	spiseq( t.bytes.hi );	/* AhX */
	spiseq( t.bytes.lo );
	data = spiseq( SPI_DUMMY );	/* Mf[^ */
	CS_NEGATE( );
#endif

	return data;
}


/**
*	W5100A
*	 in	addr: AhX
*		 buf: f[^obt@
*		 len: ݒ
*	out	Ȃ
*/
void	w5100_writebuf( word addr, byte *buf, word len )
{
	ui_t	t;
	word	i;

#if defined( DIRECT_BUS )
   	memcpy((byte *)addr, buf, len );
#elif defined( INDIRECT_BUS )
	t.data = addr;
	IDM_AR0 = t.bytes.hi;
	IDM_AR1 = t.bytes.lo;
	for( i = 0; i < len; i++, buf++ ){
		IDM_DR = *buf;
	}
#elif defined( SPI_BUS )
	for( i = 0; i < len; i++, addr++, buf++ ){
		t.data = addr;
		CS_ASSERT( );
		spiseq( SPI_WRITE );
		spiseq( t.bytes.hi );
		spiseq( t.bytes.lo );
		spiseq( *buf );
		CS_NEGATE( );
	}

#endif
}


/*
*	W5100Aǂݍ
*	 in	addr: AhX
*		 buf: i[obt@
*		 len: ǂݍݒ
*	out	Ȃ
*/ 
void	w5100_readbuf( word addr, byte *buf, word len )
{
	ui_t	t;
	word	i;

#if defined( DIRECT_BUS )
	memcpy( buf, (byte *)addr, len );
#elif defined( INDIRECT_BUS )
	t.data = addr;
	IDM_AR0 = t.bytes.hi;
	IDM_AR1 = t.bytes.lo;
	for( i = 0; i < len; i++, buf++ ){
		*buf = IDM_DR;
	}
#elif defined( SPI_BUS )
	for( i = 0; i < len; i++, addr++, buf++ ){
		t.data = addr;
		CS_ASSERT( );
		spiseq( SPI_READ );	/* ǂݍ݃R}h */
		spiseq( t.bytes.hi );	/* AhX */
		spiseq( t.bytes.lo );
		*buf = spiseq( SPI_DUMMY );	/* Mf[^ */
		CS_NEGATE( );
	}
#endif
}

/* -------------------- RWX^ -------------------- */

/**
*	đԐݒ
*	 in	l
*	out	Ȃ
*/
void	set_retrytime( word timeout )
{
	ui_t	t;

	t.data = timeout;
	w5100_write( RTR0, t.bytes.hi );
	w5100_write( RTR1, t.bytes.lo );
}


/**
*	đԎ擾
*	 in	Ȃ
*	out	đ
*/
word	get_retrytime( void )
{
	ui_t	t;

	t.bytes.hi = w5100_read( RTR0 );
	t.bytes.lo = w5100_read( RTR1 );

	return	t.data;
}


/**
*	đ񐔐ݒ
*	 in	đ
*	out	Ȃ
*/
void	set_retrycnt( byte retry )
{
	w5100_write( RCR, retry );
}


/**
*	đ񐔎擾
*	 in	Ȃ
*	out	đ
*/
byte	get_retrycnt( void )
{
	return	w5100_read( RCR );
}


/**
*	\[XhoAhXݒ
*	 in	IPAhX
*	out	Ȃ
*/
void	set_srcipaddr( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( SIPR0, t.bytes.hh );
	w5100_write( SIPR1, t.bytes.hl );
	w5100_write( SIPR2, t.bytes.lh );
	w5100_write( SIPR3, t.bytes.ll );
}


/**
*	\[XIPAhX擾
*	 in	Ȃ
*	out	IPAhX
*/
dword	get_srcipaddr( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( SIPR0 );
	t.bytes.hl = w5100_read( SIPR1 );
	t.bytes.lh = w5100_read( SIPR2 );
	t.bytes.ll = w5100_read( SIPR3 );

	return	t.data;
}


/**
*	Tulbg}XNݒ
*	 in	lbg}XN
*	out	Ȃ
*/
void	set_netmask( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( SUBR0, t.bytes.hh );
	w5100_write( SUBR1, t.bytes.hl );
	w5100_write( SUBR2, t.bytes.lh );
	w5100_write( SUBR3, t.bytes.ll );
}

/**
*	Tulbg}XN擾
*	 in	Ȃ
*	out	lbg}XN
*/
dword	get_netmask( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( SUBR0 );
	t.bytes.hl = w5100_read( SUBR1 );
	t.bytes.lh = w5100_read( SUBR2 );
	t.bytes.ll = w5100_read( SUBR3 );

	return	t.data;
}


/*
*	Q[gEFCAhXݒ
*	 in	Q[gEFCAhX
*	out	Ȃ
*/
void	set_gateway( dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( GAR0, t.bytes.hh );
	w5100_write( GAR1, t.bytes.hl );
	w5100_write( GAR2, t.bytes.lh );
	w5100_write( GAR3, t.bytes.ll );
}


/**
*	Q[gEFCAhX擾
*	 in	Ȃ
*	out	Q[gEFCAhX
*/
dword	get_gateway( void )
{
	ul_t	t;

	t.bytes.hh = w5100_read( GAR0 );
	t.bytes.hl = w5100_read( GAR1 );
	t.bytes.lh = w5100_read( GAR2 );
	t.bytes.ll = w5100_read( GAR3 );

	return	t.data;
}


/**
*	\[XMACAhXݒ
*	 in	MACAhXobt@
*	out	Ȃ
*/
void	set_macaddress( byte *addr )
{
	w5100_write( SHAR0, *addr );
	addr++;
	w5100_write( SHAR1, *addr );
	addr++;
	w5100_write( SHAR2, *addr );
	addr++;
	w5100_write( SHAR3, *addr );
	addr++;
	w5100_write( SHAR4, *addr );
	addr++;
	w5100_write( SHAR5, *addr );
}


/**
*	\[XMACAhX擾
*	 in	i[obt@
*	out	Ȃ
*/
void	get_macaddress( byte *addr )
{
	*addr = w5100_read( SHAR0 );
	addr++;
	*addr = w5100_read( SHAR1 );
	addr++;
	*addr = w5100_read( SHAR2 );
	addr++;
	*addr = w5100_read( SHAR3 );
	addr++;
	*addr = w5100_read( SHAR4 );
	addr++;
	*addr = w5100_read( SHAR5 );
}


/* -------------------- \Pbgʑ ---------------------- */


/**
*	\Pbg [hݒ
*	 in	 sn: \Pbgԍ
*		val: l
*	out	Ȃ
*/
void	setsn_mr( char sn, byte val )
{
	w5100_write( sn_mr[sn], val );
}


/**
*	\Pbg [h擾
*	 in	\Pbgԍ
*	out	l
*/
byte	getsn_mr( char sn )
{
	return	w5100_read( sn_mr[sn] );;
}


/**
*	\Pbg CRݒ
*	 in	 sn: \Pbgԍ
*		val: l
*	out	Ȃ
*/
void	setsn_cr( char sn, byte val )
{
	w5100_write( sn_cr[sn], val );
}


/**
*	\Pbg CR擾
*	 in	\Pbgԍ
*	out	l
*/
byte	getsn_cr( char sn )
{
	return	w5100_read( sn_cr[sn] );;
}


/**
*	\Pbg̊荞݃Xe[^Xݒ
*	 in	sn	\Pbgԍ
*		val	Xe[^X
*	out	Ȃ
*/
void	setsn_ir( char sn, byte val )
{
	w5100_write( sn_ir[sn], val );
}


/**
*	\Pbg̊荞݃Xe[^X擾
*	 in	\Pbgԍ
*	out	Xe[^X
*/
byte	getsn_ir( char sn )
{
	return w5100_read( sn_ir[sn] );
}


/**
*	\PbgXe[^X擾
*	 in	\Pbgԍ
*	out	Xe[^X
*/
byte	getsn_sr( char sn )
{
	return w5100_read( sn_sr[sn] );
}


/**
*	\Pbg M|[gݒ
*	 in	  sn: \Pbgԍ
*		addr: |[gԍ
*	out	Ȃ
*/
void	setsn_srcport( char sn, word port )
{
	ui_t	t;

	t.data = port;
	w5100_write( sn_port0[sn], t.bytes.hi );
	w5100_write( sn_port1[sn], t.bytes.lo );
}


/**
*	\Pbg M|[g擾
*	 in	\Pbgԍ
*	out	|[gԍ
*/
word	getsn_srcport( char sn )
{
	ui_t	t;

	t.bytes.hi = w5100_read( sn_port0[sn] );
	t.bytes.lo = w5100_read( sn_port1[sn] );

	return	t.data;
}


/**
*	\Pbg̑MMACAhXݒ
*	 in	  sn: \Pbgԍ
*		addr: MACAhX
*	out	Ȃ
*/
void	setsn_destmac( char sn, byte *addr )
{
	w5100_write( sn_dhar0[sn], *addr );
	addr++;
	w5100_write( sn_dhar1[sn], *addr );
	addr++;
	w5100_write( sn_dhar2[sn], *addr );
	addr++;
	w5100_write( sn_dhar3[sn], *addr );
	addr++;
	w5100_write( sn_dhar4[sn], *addr );
	addr++;
	w5100_write( sn_dhar5[sn], *addr );
}


/**
*	\Pbg MMACAhX擾
*	 in	  ch: \Pbgԍ
*		addr: MACAhXi[
*	out	Ȃ
*/
void	getsn_destmac( char sn, byte *addr )
{
	*addr = w5100_read( sn_dhar0[sn] );
	addr++;
	*addr = w5100_read( sn_dhar1[sn] );
	addr++;
	*addr = w5100_read( sn_dhar2[sn] );
	addr++;
	*addr = w5100_read( sn_dhar3[sn] );
	addr++;
	*addr = w5100_read( sn_dhar4[sn] );
	addr++;
	*addr = w5100_read( sn_dhar5[sn] );
}


/**
*	\Pbg MIPAhXݒ
*	 in	  ch: \Pbgԍ
*		addr: IPAhX
*	out	Ȃ
*/
void	setsn_destip( char sn, dword addr )
{
	ul_t	t;

	t.data = addr;
	w5100_write( sn_dipr0[sn], t.bytes.hh );
	addr++;
	w5100_write( sn_dipr1[sn], t.bytes.hl );
	addr++;
	w5100_write( sn_dipr2[sn], t.bytes.lh );
	addr++;
	w5100_write( sn_dipr3[sn], t.bytes.ll );
}


/**
*	\Pbg MIPAhX擾
*	 in	\Pbgԍ
*	out	IPAhX
*/
dword	getsn_destip( char sn )
{
	ul_t	t;

	t.bytes.hh = w5100_read( sn_dipr0[sn] );
	t.bytes.hl = w5100_read( sn_dipr1[sn] );
	t.bytes.lh = w5100_read( sn_dipr2[sn] );
	t.bytes.ll = w5100_read( sn_dipr3[sn] );

	return	t.data;
}


/**
*	\Pbg M|[gݒ
*	 in	  sn: \Pbgԍ
*		addr: |[gԍ
*	out	Ȃ
*/
void	setsn_destport( char sn, word port )
{
	ui_t	t;

	t.data = port;
	w5100_write( sn_dport0[sn], t.bytes.hi );
	w5100_write( sn_dport1[sn], t.bytes.lo );
}


/**
*	\Pbg M|[g擾
*	 in	\Pbgԍ
*	out	|[gԍ
*/
word	getsn_destport( char sn )
{
	ui_t	t;

	t.bytes.hi = w5100_read( sn_dport0[sn] );
	t.bytes.lo = w5100_read( sn_dport1[sn] );

	return	t.data;
}


/**
*	\Pbg MSSݒ
*	 in	\Pbgԍ
*	out	MSSl
*/
void	setsn_mss( char sn, word mss )
{
	ui_t	t;

	t.data = mss;
	w5100_write( sn_mssr0[sn], t.bytes.hi );
	w5100_write( sn_mssr1[sn], t.bytes.lo );
}


/**
*	\Pbg MSS擾
*	 in	\Pbgԍ
*	out	MSSl
*/
word	getsn_mss( char sn )
{
	ui_t	t;

	t.bytes.hi = w5100_read( sn_mssr0[sn] );
	t.bytes.lo = w5100_read( sn_mssr1[sn] );

	return	t.data;
}


/**
*	\Pbg TTLݒ
*	 in	\Pbgԍ
*	out	TTLl
*/
void	setsn_ttl( char sn, byte val )
{
	w5100_write( sn_ttl[sn], val );
}

/**
*	\Pbg TTL擾
*	 in	\Pbgԍ
*	out	TTLl
*/
byte	getsn_ttl( char sn )
{
	return	w5100_read( sn_ttl[sn] );
}


/**
*	IPwb_̃vgRԍZbg(IP RAW[h)
*	 in	   sn: \Pbgԍ
*		proto: vgRԍ
*	out	Ȃ
*/
void	setsn_proto( char sn, byte proto )
{
	w5100_write( sn_proto[sn], proto );
}


/**
*	IPwb_̃vgRԍ擾(IP RAW[h)
*	 in	\Pbgԍ
*	out	vgRԍ
*/
byte	getsn_proto( char sn )
{
	return	w5100_read( sn_proto[sn] );
}


/**
*	\Pbg̑M󂫃obt@TCY擾
*	 in	\Pbgԍ
*	out	TCY
*/
word	getsn_tx_fsr( char sn )
{
	ui_t	val, val1;
	word	fsr0, fsr1;

	val.data = val1.data = 0;
	fsr0 = sn_tx_fsr0[sn];
	fsr1 = sn_tx_fsr1[sn];
	do{	/* ǂłrōXV̂ */
		val1.bytes.hi = w5100_read( fsr0 );
		val1.bytes.lo = w5100_read( fsr1 );
		if( val1.data != 0 ){
			val.bytes.hi = w5100_read( fsr0 );
			val.bytes.lo = w5100_read( fsr1 );
		}
	} while( val.data != val1.data );

	return	val.data;
}


/**
*	\Pbg̑Mݒ
*	 in	\Pbgԍ
*	out	Ȃ
*/
void	setsn_tx_wr( char sn, word data )
{
	ui_t	val;

	val.data = data;
	w5100_write( sn_tx_wr0[sn], val.bytes.hi );
	w5100_write( sn_tx_wr1[sn], val.bytes.lo );
}


/**
*	\Pbg̑M擾
*	 in	\Pbgԍ
*	out	TCY
*/
word	getsn_tx_wr( char sn )
{
	ui_t	val;

	val.bytes.hi = w5100_read( sn_tx_wr0[sn] );
	val.bytes.lo = w5100_read( sn_tx_wr1[sn] );

	return	val.data;
}


/**
*	\Pbg̎Mς݃obt@TCY擾
*	 in	\Pbgԍ
*	out	TCY
*/
word	getsn_rx_rsr( char sn )
{
	ui_t	val, val1;
	word	rsr0, rsr1;

	val.data = val1.data = 0;
	rsr0 = sn_rx_rsr0[sn];
	rsr1 = sn_rx_rsr1[sn];
	do{
		val1.bytes.hi = w5100_read( rsr0 );
		val1.bytes.lo = w5100_read( rsr1 );
		if( val1.data != 0 ){
			val.bytes.hi = w5100_read( rsr0 );
			val.bytes.lo = w5100_read( rsr1 );
		}
	} while( val.data != val1.data );

	return	val.data;
}


/**
*	\Pbg̎Mǂݎ|C^ݒ
*	 in	sn	\Pbgԍ
*		pnt	|C^
*	out	Ȃ
*/
void	setsn_rx_rd( char sn, word pnt )
{
	ui_t	val;

	val.data = pnt;
	w5100_write( sn_rx_rd0[sn], val.bytes.hi );
	w5100_write( sn_rx_rd1[sn], val.bytes.lo );
}


/**
*	\Pbg̎Mǂݎ|C^擾
*	 in	\Pbgԍ
*	out	|C^
*/
word	getsn_rx_rd( char sn )
{
	ui_t	val;

	val.bytes.hi = w5100_read( sn_rx_rd0[sn] );
	val.bytes.lo = w5100_read( sn_rx_rd1[sn] );

	return	val.data;
}


/* ---------- M ---------- */


/**
*	W5100̎Mobt@f[^o
*	 in	sn	\Pbgԍ
*		src	Rs[obt@AhX(W5100)
*		dst	i[擪AhX
*		len	M
*	out	i[obt@擪AhX
*/
byte	*read_data( char sn, word src, byte *dst, word len )
{
	word	ofst, max;
	word	base, rptr, usize, lsize;

	ofst = src & socksts[sn].rxmask;
	base = socksts[sn].rxbufbaseaddr;	/* obt@̐擪AhX */
	rptr = base + ofst;		/* ǂݏoJnAhXvZ */
	max = socksts[sn].rxsize;
	if(( ofst + len ) > max ){	/* f[^܂ԂĂ */
		usize = max - ofst;
		w5100_readbuf( rptr, dst, usize );	/* Oǂݏo */
		dst += usize;
		lsize = len - usize;
		w5100_readbuf( base, dst, lsize );	/* 㔼ǂݏo */
	}
	else{
		w5100_readbuf( rptr, dst, len );
	}
	return	dst;
}


/**
*	f[^𑗐M
*	 in	sn	\Pbgԍ
*		data	Mf[^obt@
*		len	M
*	out	Ȃ
*/
void	send_data( char sn, byte *data, word len )
{
	word	base, ofst, max;
	word	wptr, nptr, usize, lsize;

	nptr = getsn_tx_wr( sn );	/* TX|C^lǂ */
	ofst = nptr & socksts[sn].txmask;	/* AhXItZbgvZ */
	base = socksts[sn].txbufbaseaddr;
	wptr = base + ofst;		/* ݊JnAhXvZ */
	max = socksts[sn].txsize;
	if(( ofst + len ) > max ){	/* ܂ԂĂ */
		usize = max - ofst;	/* O݃TCY */
		w5100_writebuf( wptr, data, usize );
		data += usize;
		lsize = len - usize;	/* cTCY */
		w5100_writebuf( base, data, lsize );
	} 
	else{		/*  */
		w5100_writebuf( wptr, data, len );
	}
	nptr += len;
	setsn_tx_wr( sn, nptr );	/* TX݃|C^XV */
}


/**
*	f[^M
*	 in	sn	\Pbgԍ
*		data	f[^i[obt@
*		len	M
*	out	Ȃ
*/
void	recv_data( char sn, byte *data, word len )
{
	word	nptr;

	nptr = getsn_rx_rd( sn );	/* RX|C^l */
	read_data( sn, nptr, data, len );	/* f[^ǂݏo */
	nptr += len;
	setsn_rx_rd( sn, nptr );	/* RX|C^XV */
}


/* --------------------  ---------------------- */


/**
*	W5100
*	 in	Ȃ
*	out	Ȃ
*/
void	w5100_init( void )
{
	byte	buf[8] = { 0x00, 0x50, 0xc2, 0x96, 0x00, 0x00 };
	/* eXgpMACAhXȂ̂ŁAeŗpӂ邱 */

	w5100_write( MR, MR_RST );	/* \tgEFAZbg */
#if defined( INDIRECT_BUS )
	set_modereg( MR_IND | MR_AI );	/* C_CNgoXݒ */
#endif
	set_macaddress( buf );		/* MACAhX */
	set_srcipaddr( 0xc0a80066 );	/* IPAhX 192.168.0.102 */
	set_netmask( 0xffffff00 );	/* lbg}XN 255.255.255.0 */
	set_gateway( 0xc0a80001 );	/* Q[gEFC 192.168.0.1 */

}


/**
*	W5100̃
*	bit 1-0 : `lOTCY
*	bit 3-2 : `lPTCY
*	bit 5-4 : `lQTCY
*	bit 7-6 : `lRTCY
*	 00:1KByte, 01:2KBtye, 10:4KByte, 11:8KByte
*/ 
void	w5100_meminit( byte tx_size, byte rx_size )
{
	word	i, c, ssum, rsum, tsize, rsize;

	ssum = 0;
	rsum = 0;
	w5100_write( TMSR, tx_size );	/* e`lMTCYZbg */
	w5100_write( RMSR, rx_size );	/* e`lMTCYZbg */

	for( i = 0 ; i < MAX_SOCKET; i++ ){	/* e`l̑MEMTCYXe[^XɃZbg */
		tsize = rsize = 0;
		if( ssum < 8192U ){	/* v8KoCg𒴂ĂȂꍇ */
			c = tx_size & 0x03;
			switch( c ){		/* TCY */
				 case 0:	tsize = 1024U;
				_case 1:	tsize = 2048U;
				_case 2:	tsize = 4096U;
				_case 3:	tsize = 8192U;
						break;
			}
			socksts[i].txmask = tsize - 1U;	/* }XNrbg */
			tx_size >>= 2;
		}
		socksts[i].txsize = tsize;
		if( rsum < 8192U ){	/* v8KoCg𒴂ĂȂꍇ */
			c = rx_size & 0x03;
			switch( c ){		/* TCY */
				 case 0:	rsize = 1024U;
				_case 1:	rsize = 2048U;
				_case 2:	rsize = 4096U;
				_case 3:	rsize = 8192U;
						break;
			}
			socksts[i].rxmask = rsize - 1U;	/* }XNrbg */
			rx_size >>= 2;
		}
		socksts[i].rxsize = rsize;
		socksts[i].txbufbaseaddr = W5100_TXBUF + ssum;	/* Mx[XAhX */
		socksts[i].rxbufbaseaddr = W5100_RXBUF + rsum;	/* Mx[XAhX */
		ssum += tsize;
		rsum += rsize;
	}
}


/* end of w5100.c */
